SYS4B/ 	ORG	4E00H
 ;SYS4B/ASM
 	DB	'FD'
 	DW	ERROR,RET,RET,RET,RET,RET,RET,RET
 	DW	RET,RET,RET,RET,RET,RET,RET
 ERROR	POP	AF		;get error code
 	PUSH	AF		;save on stack
 	AND	3FH		;mask high 2 bits off
 	LD	B,A		;save it here for test
 	LD	C,0		;counter initial
 	LD	HL,TABLE2	;command lookup table
 	CP	45		;44 errors here
 	JR	C,FINDERR	;valid if <45
 	LD	HL,UNDEFINE	;undefined error code
 	CALL	4467H		;display it
 ERRDONE	LD	A,13		;send a linefeed
 	CALL	VOUT
 	POP	AF		;get error back
 	AND	0C0H		;check top 2 bits
 	RET	NZ		;return if either set
 	JP	402DH		;back to dos
 FINDERR	BIT	7,(HL)		;high bit on ?
 	INC	HL		;bump pointer
 	JR	Z,FINDERR	;continue
 	LD	A,B		;get error request
 	CP	C		;correct one ?
 	JR	Z,SHOERR	;yes, display it
 	INC	C		;bump counter
 	JR	FINDERR		;continue through table
 SHOERR	DEC	HL		;point to start of line
 	RES	7,(HL)		;high bit off
 ERRLOOP	LD	A,(HL)		;get a table byte
 	BIT	7,A		;terminator ?
 	JR	NZ,ERRDONE	;finished
 	CALL	SHOW1		;show the word
 	INC	HL		;bump pointer
 	JR	ERRLOOP		;continue with sentence
 SHOW1	LD	B,A		;get the word number
 	LD	C,1		;counter
 	PUSH	HL		;save pointer
 	LD	HL,TABLE1	;word table
 FINDSHO	BIT	7,(HL)		;high bit on/word start?
 	INC	HL		;bump pointer
 	JR	Z,FINDSHO	;continue if not
 	LD	A,C		;get count
 	CP	B		;one we want ?
 	JR	Z,PUTERR	;display the word
 	INC	C
 	JR	FINDSHO		;else continue
 PUTERR	DEC	HL		;word start
 	LD	A,(HL)		;get first byte
 	AND	7FH		;remove high bit
 	JR	PUTLOOP+1	;print it
 PUTLOOP	LD	A,(HL)		;get a byte
 	BIT	7,A		;end of word
 	JR	NZ,WORDEND
 	CALL	VOUT		;display the byte
 	INC	HL		;bump pointer
 	JR	PUTLOOP		;continue
 WORDEND	LD	A,20H		;display a space
 	CALL	VOUT		;display it
 	POP	HL		;restore table pointer
 RET	RET			;done
 UNDEFINE	DB	'Undefined Error Code',13
 TABLE1	DB	'N'+80H,'O'
 	DB	'E'+80H,'rror'
 	DB	'P'+80H,'arity'
 	DB	'o'+80H,'n'
 	DB	'H'+80H,'eader'
 	DB	'R'+80H,'ead'
 	DB	'S'+80H,'eek'
 	DB	'L'+80H,'OST'
 	DB	'D'+80H,'ATA'
 	DB	'R'+80H,'ECORD'
 	DB	'N'+80H,'OT'
 	DB	'F'+80H,'OUND'
 	DB	'A'+80H,'ttempted'
 	DB	't'+80H,'o'
 	DB	'S'+80H,'YSTEM'
 	DB	'D'+80H,'evice'
 	DB	'A'+80H,'VAILABLE'
 	DB	'W'+80H,'rite'
 	DB	'F'+80H,'AULT'
 	DB	'D'+80H,'isk'
 	DB	'D'+80H,'rive'
 	DB	'D'+80H,'iskette'
 	DB	'P'+80H,'ROTECTED'
 	DB	'I'+80H,'llegal'
 	DB	'L'+80H,'ogical'
 	DB	'F'+80H,'ile'
 	DB	'N'+80H,'umber'
 	DB	'D'+80H,'irectory'
 	DB	'N'+80H,'ame'
 	DB	'G'+80H,'AT'
 	DB	'H'+80H,'IT'
 	DB	'i'+80H,'n'
 	DB	'A'+80H,'CCESS'
 	DB	'D'+80H,'ENIED'
 	DB	'S'+80H,'PACE'
 	DB	'F'+80H,'ULL'
 	DB	'E'+80H,'OF'
 	DB	'E'+80H,'ncountered'
 	DB	'N'+80H,'ext'
 	DB	'R'+80H,'ecord'
 	DB	'o'+80H,'ut'
 	DB	'o'+80H,'f'
 	DB	'R'+80H,'ange'
 	DB	'P'+80H,'rogram'
 	DB	'f'+80H,'or'
 	DB	'N'+80H,'ew'
 	DB	'L'+80H,'oad'
 	DB	'F'+80H,'ormat'
 	DB	'M'+80H,'emory'
 	DB	'A'+80H,'ttempted'
 	DB	'R'+80H,'OM'
 	DB	'C'+80H,'ANNOT'
 	DB	'h'+80H,'as'
 	DB	'b'+80H,'een'
 	DB	'O'+80H,'ened'
 	DB	'R'+80H,'eady'
 	DB	'D'+80H,'AM'
 	DB	'L'+80H,'ocate'
 	DB	'K'+80H,'im Watt'
 	DB	'b'+80H,'y'
 	DB	'V'+80H,'ern Hester'
 	DB	'D'+80H,'OS'
 	DB	'a'+80H,'nd'
 	DB	80H
 TABLE2	DB	1+80H,2		;0
 	DB	3+80H,2,4,5,6	;1
 	DB	7+80H,2,4,6	;2
 	DB	8+80H,9,4,6	;3
 	DB	3+80H,2,4,6	;4
 	DB	9+80H,10,11,12,4,6	;5
 	DB	13+80H,14,6,15,9,10	;6
 	DB	13+80H,14,6,15,9,10	;7
 	DB	16+80H,11,17	;8
 	DB	3+80H,2,4,5,18	;9
 	DB	7+80H,2,4,18	;10
 	DB	8+80H,9,4,18	;11
 	DB	3+80H,2,4,18	;12
 	DB	9+80H,10,11,12,4,18	;13
 	DB	18+80H,19,4,20,21	;14
 	DB	22+80H,18,23	;15
 	DB	24+80H,25,26,27	;16
 	DB	28+80H,6,2	;17
 	DB	28+80H,18,2	;18
 	DB	24+80H,26,29	;19
 	DB	30+80H,6,2	;20
 	DB	30+80H,18,2	;21
 	DB	31+80H,6,2	;22
 	DB	31+80H,18,2	;23
 	DB	26+80H,11,32,28	;24
 	DB	26+80H,33,34	;25
 	DB	28+80H,35,36	;26
 	DB	20+80H,35,36	;27
 	DB	37+80H,38	;28
 	DB	39+80H,40,41,42,43	;29
 	DB	36+80H,28	;30
 	DB	44+80H,11,12	;31
 	DB	24+80H,21,27	;32
 	DB	1+80H,35,45,46,16	;33
 	DB	47+80H,26,48,2	;34
 	DB	49+80H,19	;35
 	DB	50+80H,14,47,51,49	;36
 	DB	52+80H,33,23,26	;37
 	DB	26+80H,53,11,54,55	;38
 	DB	44+80H,2	;39
 	DB	21+80H,11,56	;40
 	DB	21+80H,11,32,15	;41
 	DB	24+80H,57	;42
 	DB	52+80H,58,28	;43
 	DB	62+80H,60,59,63,61	;44
 	DB	80H
 VOUT	PUSH	DE
 	CALL	33H
 	POP	DE
 	RET
 	END	4E00H
 	DB	44+80H,2	;39
 	DB	21+80H,11,56	;40
 	DB	21+